<?php
 /*
   Limph Is Monitoring Pingable Hosts
   Copyright (C) 2006 Jonathan Ciesla
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
  */
require_once("config.php");
require_once("functionlib.php");
session_start();
favicon();

$link = dbms_connect($dbhost, $dbuser, $dbpass, $dbname);

authentication(0,0);

$ip = dbms_escape_string($_POST['ip']);
if(!$ip&&$_POST['host']){
  $host = dbms_escape_string($_POST['host']);
  $ip=gethostbyname($host);
 };

if(!$host&&$ip){$host = gethostbyaddr($ip);};

$rstart = dbms_escape_string($_POST['rstart']);
$rend = dbms_escape_string($_POST['rend']);
$port = dbms_escape_string($_POST['port']);
$prot = dbms_escape_string($_POST['prot']);

echo "<link rel=stylesheet href=css.php>";
echo "<table border=1 cellpadding=5 align=center width=%100>";
echo "<tr><th>Port scanner</th></tr>";

echo "<form action=port_scan.php method=post>";
echo "<tr><td align=right>";
echo "Name:<input type=text name=host value=\"$host\">";
echo "</td></tr><tr><td align=right>";
echo "IP:<input type=text name=ip size=15 value=\"$ip\"><br />";
echo "Leave blank to obtain from DNS";
echo "</td></tr><tr><td align=right>";
echo "Protocol:  ";
$icmpcheck = "checked";
if($prot=="icmp"){$tcpcheck=""; $udpcheck=""; $icmpcheck="checked";};
if($prot=="tcp"){$tcpcheck="checked"; $udpcheck=""; $icmpcheck="";};
if($prot=="udp"){$tcpcheck=""; $udpcheck="checked"; $icmpcheck="";};
echo "ICMP:<input type=radio name=prot value=icmp $icmpcheck> UDP:<input type=radio name=prot value=udp $udpcheck> TCP:<input type=radio name=prot value=tcp $tcpcheck>";
echo "TCP Port:<input type=text name=port size=4>";
echo "</td></tr><tr><td align=right>";
echo "Range Start:<input type=text name=rstart size=4> End:<input type=text name=rend size=4><br />";
echo "Defaults to 1-1024";
echo "</td></tr><tr><td align=center>";
echo "<input type=submit value=Scan>";
echo "</td></tr>";
echo "</form>";
echo "</table>";

if($prot=="tcp"){  
  if((!$port)&&(!$rstart)&&(!$rend)){
    $rstart = "1";
    $rend = "1024";
  };
  
  if($ip){
    $safety = udp_ping($ip, 1); //Keeps unreachable hosts from potentially hanging the whole webserver.  A hack, but good enough.
    if((($rstart)&&($rend))&&($rstart<$rend)&&($safety=="1")){
      $title = "Port Range $rstart - $rend on";
      if($host){$title = $title . " " . $host;}else{$title = $title . " " . $ip;};
      echo $title;
      echo "<br />";
      for($x=$rstart;$x<=$rend;$x++){
	$status = tcp_check($ip, 1, $x);
	if($status=="1"){
	  $report = "$x:" . getservbyport($x, "tcp") . ":Open";
	  echo $report;
	  echo "<br />";
	};
      };
    };
    
    if($port){
      $status = tcp_check($ip, 1, $port);
      if($status==1){$status="Open";}else{$status="Closed";};
      $report = "$port:$status";
      if($host){$report = "$host:" . $report;}else{$report = "$ip:" . $report;};
      echo $report;
    echo "<br />";
    };
  }; //end ip
 }; //end tcp

if($prot=="udp"){
  if($ip){
    $status = udp_ping($ip, 1);
    if($status==1){$status="Open";}else{$status="Closed";};
    $report = "UDP:$status";
    if($host){$report = "$host:" . $report;}else{$report = "$ip:" . $report;};
    echo $report;
    echo "<br />";
  };
 };
 
 if($prot=="icmp"){
  if($ip){
    $status = icmp_check($ip);
    if($status==1){$status="Open";}else{$status="Closed";};
    $report = "ICMP:$status";
    if($host){$report = "$host:" . $report;}else{$report = "$ip:" . $report;};
    echo $report;
    echo "<br />";
  };
 };

?>
